module.exports = {
  parser: '@typescript-eslint/parser',
  parserOptions: {
    project: 'tsconfig.json',
    tsconfigRootDir: __dirname,
    sourceType: 'module',
  },
  extends: ['plugin:@typescript-eslint/recommended', 'plugin:prettier/recommended', 'airbnb/base', 'airbnb-typescript/base', 'prettier'],
  plugins: ['@typescript-eslint/eslint-plugin', 'prettier'],
  root: true,
  env: {
    node: true,
    jest: true,
  },
  ignorePatterns: ['.eslintrc.js'],
  rules: {
    'prettier/prettier': 'error',
    'eol-last': ['error', 'always'],
    '@typescript-eslint/semi': ['error', 'never'],

    // disabled
    '@typescript-eslint/interface-name-prefix': 'off',
    '@typescript-eslint/explicit-function-return-type': 'off',
    '@typescript-eslint/explicit-module-boundary-types': 'off',
    '@typescript-eslint/no-explicit-any': 'off',
    '@typescript-eslint/return-await': 'off',
    "no-underscore-dangle": ["error", { "allow": ["_count"] }], // prisma
    'no-nested-ternary': 'off',
    'no-param-reassign': 'off',
    'no-plusplus': 'off',
    "no-continue": "off", 
    'import/no-unresolved': 'off', 
    'import/no-extraneous-dependencies': 'off',
    'class-methods-use-this': 'off'
  },
}
